<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>Bank Web</title>
    <link rel="stylesheet" href="css/bootstrap.min.css" />
    <link rel="stylesheet" href="css/jquery-ui.min.css" />
    <link rel="stylesheet" href="css/bank.css" />
</head>

<body>

    <!-- Container. -->
    <div class="container">

        <!-- Logo. -->
        <img src="static/logo.jpg"
             style="padding-top: 30px; padding-bottom: 30px;" />

        <!-- Menu. -->
        <ul class="nav nav-pills mb-3">
            <li class="nav-item">
                <a class="nav-link active" id="accounts-tab"
                   data-toggle="pill" href="#accounts"
                   aria-selected="true">Accounts</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" id="transactions-tab"
                   data-toggle="pill" href="#transactions"
                   role="tab" aria-controls="transactions"
                   aria-selected="false">Transactions</a>
            </li>
            <li class="nav-item dropdown">
                <a id="user_name" class="nav-link dropdown-toggle"
                   data-toggle="dropdown" href="#" role="button"
                   aria-haspopup="true" aria-expanded="false">Unknown</a>
                <div class="dropdown-menu">
                    <a class="dropdown-item" href="/bank/logout">Logout</a>
                </div>
            </li>
        </ul>

        <div class="tab-content">

            <!-- Customer list. -->
            <div id="accounts" class="tab-pane fade show active"
                 role="tabpanel" aria-labelledby="accounts-tab">
                <table class="table table-striped">
                    <thead>
                        <th scope="col">ID</th>
                        <th scope="col">First name</th>
                        <th scope="col">Last name</th>
                        <th scope="col">Birthday</th>
                        <th scope="col">Address</th>
                        <th scope="col">Accounts</th>
                        <th></th>
                    </thead>
                    <tbody id="customer_list"></tbody>
                </table>
                <button type="button" class="btn btn-primary"
                        onclick="prepareCustomerAdd()">Add</button>
            </div>

            <!-- Transactions. -->
            <div id="transactions" class="tab-pane fade"
                 role="tabpanel" aria-labelledby="transactions-tab">
                Siia te teete kõik iseseisvalt ülekannete funktsionaalsuse :)
            </div>

        </div>


        <!-- Customer modal. -->
        <div class="modal fade" id="customer_modal"
             tabindex="-1" role="dialog"
             aria-labelledby="customer_modal_label"
             aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title"
                            id="customer_modal_label">
                            Add/Edit Customer
                        </h5>
                        <button type="button" class="close"
                                data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">x</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form name="customerForm">
                            <input type="hidden" id="id" name="id" value="0" />
                            <input type="text" id="firstname" name="firstname"
                                   class="form-control" placeholder="First name" /><br />
                            <input type="text" id="surname" name="surname"
                                   class="form-control" placeholder="Last name" /><br />
                            <input type="text" id="birthday" name="birthday"
                                   readonly="readonly" class="form-control"
                                   placeholder="Birthday" /><br />
                            <input type="text" id="address" name="address"
                                   class="form-control" placeholder="Address" />
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                                data-dismiss="modal">Cancel</button>
                        <button type="button" class="btn btn-primary"
                                onclick="saveCustomer()"
                                data-dismiss="modal">Submit</button>
                    </div>
                </div>
            </div>
        </div>

        <!-- License. -->
        <div style="padding-top: 30px;">
            <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">
                <img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc-sa/4.0/88x31.png" />
            </a><br />
            This work is licensed under a
            <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/4.0/">
                Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License</a>.
        </div>

    </div>

    <script src="js/jquery.min.js"></script>
    <script src="js/jquery-ui.min.js"></script>
    <script src="js/popper.min.js"></script>
    <script src="js/bootstrap.min.js"></script>

    <script>

        $(document).ready(
            function() {
                initUIControls();
                giveMeUser();
                giveMeAllCustomers();
            }
        );

        function initUIControls() {
            $('#birthday').datepicker(
                {
                    dateFormat: 'dd.mm.yy',
                    showButtonPanel: true,
                    changeMonth: true,
                    changeYear: true,
                    changeOtherMonths: true,
                    selectOtherMonths: true,
                    yearRange: "-300:+0"
                }
            );
        }

        function giveMeUser() {
            $.ajax(
                {
                    method: "GET",
                    url: "/bank/user",
                    dataType: "json",
                    contentType: "application/json",
                    complete: function(response) {
                        if (response.status == '401') {
                            window.location.href = '/bank/login';
                        }
                        var user = response.responseJSON;
                        $('#user_name').html(user.name);
                    }
                }
            );
        }

        function giveMeAllCustomers() {
            $.ajax(
                {
                    method: "GET",
                    url: "/bank/customer/list",
                    dataType: "json",
                    contentType: "application/json",
                    complete: function(response) {
                        if (response.status == '401') {
                            window.location.href = '/bank/login';
                        }
                        $('#customer_list').empty();
                        var customers = response.responseJSON;
                        for (var i = 0; i < customers.length; i++) {
                            var row = "<tr>";
                            row = row + "<td>" + customers[i].id + "</td>";
                            row = row + "<td>" + customers[i].firstname + "</td>";
                            row = row + "<td>" + customers[i].surname + "</td>";
                            row = row + "<td>" + customers[i].birthday + "</td>";
                            row = row + "<td>" + customers[i].address + "</td>";
                            row = row + "<td>";
                            for (var j = 0; j < customers[i].accounts.length; j++) {
                                row = row + customers[i].accounts[j].accountNumber + "<br />";
                            }
                            row = row + "</td>";

                            row = row + "<td>";
                            row = row + '<button class="btn btn-sm" onclick="prepareCustomer(' + customers[i].id + ');">Edit</button>&nbsp;'
                                + '<button class="btn btn-sm btn-danger" onclick="deleteCustomer(' + customers[i].id + ');">Delete</button>';
                            row = row + "</td>";

                            row = row + "</tr>";
                            $('#customer_list').append(row);
                        }
                    }
                }
            );
        }

        function prepareCustomerAdd() {
            $('#id').val(0);
            $('#firstname').val("");
            $('#surname').val("");
            $('#birthday').val("");
            $('#address').val("");
            $('#customer_modal').modal('show');
        }

        function prepareCustomer(customerId) {
            $.ajax(
                {
                    method: "GET",
                    url: "/bank/customer/get/" + customerId,
                    dataType: "json",
                    contentType: "application/json",
                    complete: function(response) {
                        var customer = response.responseJSON;
                        $('#id').val(customer.id);
                        $('#firstname').val(customer.firstname);
                        $('#surname').val(customer.surname);
                        $('#birthday').val(customer.birthday);
                        $('#address').val(customer.address);
                        $('#customer_modal').modal('show');
                    }
                }
            );
        }

        function saveCustomer() {
            $.ajax(
                {
                    method: "POST",
                    url: "/bank/customer/save",
                    dataType: "json",
                    contentType: "application/json",
                    data: JSON.stringify(getData($('form[name=customerForm]').serializeArray())),
                    complete: function(response) {
                        giveMeAllCustomers();
                    }
                }
            );
        }

        function deleteCustomer(customerId) {
            if (confirm('Are you sure?')) {
                $.ajax(
                    {
                        method: "POST",
                        url: "/bank/customer/delete/" + customerId,
                        dataType: "json",
                        contentType: "application/json",
                        complete: function(response) {
                            giveMeAllCustomers();
                        }
                    }
                );
            }
        }

        function getData(data) {
            var result = {};
            $.map(data, function(n) {
                result[n['name']] = n['value'];
            });
            return result;
        }

    </script>

</body>

</html>